--- /dev/null	2013-10-07 21:44:00.000000000 +0000
+++ new/cpp/squash.py	2013-10-07 21:44:00.034739752 +0000
@@ -0,0 +1,30 @@
+import sys
+results = {}
+buf = ''
+fname = ''
+for line in sys.stdin:
+    if line.startswith('---'):
+        if buf:
+            if buf in results:
+                results[buf].extend([fname])
+            else:
+                results[buf] = [fname]
+        buf = ''
+        fname = line.split(' ')[1]
+    elif line.startswith('+++'):
+        pass
+    elif line.startswith('@@'):
+        if buf:
+            if buf in results:
+                results[buf].extend([fname])
+            else:
+                results[buf] = [fname]
+        buf = ''
+    else:
+        buf += line
+
+for key in results.iterkeys():
+    print "From %s" % ', '.join(results[key])
+    print "="*68
+    print '   %s' % '\n   '.join(key.splitlines())
+    print
--- /dev/null	2013-10-07 21:44:00.000000000 +0000
+++ new/cpp/test.sh	2013-10-07 21:44:00.185554124 +0000
@@ -0,0 +1,42 @@
+#!/bin/bash
+
+PARSE_ONLY=0
+
+function just_body {
+    if [[ $PARSE_ONLY == 1 ]]; then
+        sed -e '/^[[:space:]]*$/d' -e '/^#/d' \
+            -e 's/^[[:space:]]\+//' -e 's/[[:space:]]\+/ /g'
+    else
+        sed -e '/^#/d' -e '/^$/d'
+    fi
+}
+
+function test_file {
+    file=$1
+    diff -L "$file (Sun cpp)" -L "$file (Joyent cpp)" -u \
+        <(/usr/lib/cpp $file 2>/dev/null | just_body) \
+        <(./cpp $file 2>/dev/null | just_body)
+}
+
+while getopts p name; do
+    case $name in
+        p) PARSE_ONLY=1;;
+    esac
+done
+shift $(($OPTIND - 1))
+
+if (( $# > 0 )); then
+    while (( $# > 0 )); do
+        test_file $1
+        shift;
+    done
+else
+    for elt in /usr/include/**/*.h; do
+        # C++ that will never parse
+        [[ $elt == */firefox/* ]] && continue
+        # Triggers pre-ANSI infinitely recursive expansion
+        [[ $elt == */ncurses/* ]] && continue
+        print -u2 "*** $elt"
+        test_file $elt
+    done
+fi
